# UserS3KeysApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                                    | HTTP request                                 | Description                     |
| --------------------------------------------------------- | -------------------------------------------- | ------------------------------- |
| [**umUsersS3keysDelete**](#umuserss3keysdelete)           | **DELETE** /um/users/{userId}/s3keys/{keyId} | Delete S3 keys                  |
| [**umUsersS3keysFindByKeyId**](#umuserss3keysfindbykeyid) | **GET** /um/users/{userId}/s3keys/{keyId}    | Retrieve user S3 keys by key ID |
| [**umUsersS3keysGet**](#umuserss3keysget)                 | **GET** /um/users/{userId}/s3keys            | List user S3 keys               |
| [**umUsersS3keysPost**](#umuserss3keyspost)               | **POST** /um/users/{userId}/s3keys           | Create user S3 keys             |
| [**umUsersS3keysPut**](#umuserss3keysput)                 | **PUT** /um/users/{userId}/s3keys/{keyId}    | Modify a S3 Key by Key ID       |
| [**umUsersS3ssourlGet**](#umuserss3ssourlget)             | **GET** /um/users/{userId}/s3ssourl          | Retrieve S3 single sign-on URLs |

## umUsersS3keysDelete

> umUsersS3keysDelete(userId, keyId, opts)

Delete S3 keys

Delete the specified user S3 key.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
// Delete S3 keys
api_instance
  .umUsersS3keysDelete({
    userId: userId_example,
    keyId: keyId_example,
    pretty: true,
    depth: 56,
    xContractNumber: 56, 
        options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                   | Notes                              |
| ------------------- | ----------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                                    | \[default to undefined]            |
| **keyId**           | **string**  | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                                  | \[default to undefined]            |
| **pretty**          | **boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                            | \[optional]\[default to true]      |
| **depth**           | **number**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children\&#39;s children are included. - depth=... and so on | \[optional]\[default to 0]         |
| **xContractNumber** | **number**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                                | \[optional]\[default to undefined] |

### Return type

nil (empty response body)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## umUsersS3keysFindByKeyId

> umUsersS3keysFindByKeyId(userId, keyId, opts)

Retrieve user S3 keys by key ID

Retrieve the specified user S3 key. The user ID is in the response body when the user is created, and in the list of the users, returned by GET. The key ID is in the response body when the S3 key is created, and in the list of all user S3 keys, returned by GET.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
// Retrieve user S3 keys by key ID
api_instance
  .umUsersS3keysFindByKeyId({
    userId: userId_example,
    keyId: keyId_example,
    pretty: true,
    depth: 56,
    xContractNumber: 56, 
        options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                   | Notes                              |
| ------------------- | ----------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                                    | \[default to undefined]            |
| **keyId**           | **string**  | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                                  | \[default to undefined]            |
| **pretty**          | **boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                            | \[optional]\[default to true]      |
| **depth**           | **number**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children\&#39;s children are included. - depth=... and so on | \[optional]\[default to 0]         |
| **xContractNumber** | **number**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                                | \[optional]\[default to undefined] |

### Return type

[**S3Key**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3key)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## umUsersS3keysGet

> umUsersS3keysGet(userId, opts)

List user S3 keys

List S3 keys by user ID. The user ID is in the response body when the user is created, and in the list of the users, returned by GET.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
var filterMap = new Map()
filterMap.set("<property_name>", "<property_value>")
// List user S3 keys
api_instance
  .umUsersS3keysGet({
    userId: userId_example,
    pretty: true,
    depth: 56,
    xContractNumber: 56, 
    orderBy: "<property_name>"
    maxResults: 2,
    filters: filterMap
    options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                   | Notes                              |
| ------------------- | ----------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                                    | \[default to undefined]            |
| **pretty**          | **boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                            | \[optional]\[default to true]      |
| **depth**           | **number**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children\&#39;s children are included. - depth=... and so on | \[optional]\[default to 0]         |
| **xContractNumber** | **number**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                                | \[optional]\[default to undefined] |

### Return type

[**S3Keys**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3keys)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## umUsersS3keysPost

> umUsersS3keysPost(userId, opts)

Create user S3 keys

Create an S3 key for the specified user. The user ID is in the response body when the user is created, and in the list of the users, returned by GET. A maximum of five keys per user can be generated.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
// Create user S3 keys
api_instance
  .umUsersS3keysPost({
    userId: userId_example,
    pretty: true,
    depth: 56,
    xContractNumber: 56, 
        options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type        | Description                                                                                                                                                                                                                                                                                                                                                                                                                                   | Notes                              |
| ------------------- | ----------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**  | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                                    | \[default to undefined]            |
| **pretty**          | **boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                            | \[optional]\[default to true]      |
| **depth**           | **number**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children\&#39;s children are included. - depth=... and so on | \[optional]\[default to 0]         |
| **xContractNumber** | **number**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                                | \[optional]\[default to undefined] |

### Return type

[**S3Key**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3key)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## umUsersS3keysPut

> umUsersS3keysPut(userId, keyId, s3Key, opts)

Modify a S3 Key by Key ID

Enables or disables the specified user S3 key.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
// Modify a S3 Key by Key ID
api_instance
  .umUsersS3keysPut({
    userId: userId_example,
    keyId: keyId_example,
    s3Key: s3Key_example,
    pretty: true,
    depth: 56,
    xContractNumber: 56, 
        options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type                                                                                           | Description                                                                                                                                                                                                                                                                                                                                                                                                                                   | Notes                              |
| ------------------- | ---------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**                                                                                     | The unique ID of the user.                                                                                                                                                                                                                                                                                                                                                                                                                    | \[default to undefined]            |
| **keyId**           | **string**                                                                                     | The unique ID of the S3 key.                                                                                                                                                                                                                                                                                                                                                                                                                  | \[default to undefined]            |
| **s3Key**           | [**S3Key**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3key) | The modified S3 key.                                                                                                                                                                                                                                                                                                                                                                                                                          |                                    |
| **pretty**          | **boolean**                                                                                    | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                            | \[optional]\[default to true]      |
| **depth**           | **number**                                                                                     | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children\&#39;s children are included. - depth=... and so on | \[optional]\[default to 0]         |
| **xContractNumber** | **number**                                                                                     | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                                | \[optional]\[default to undefined] |

### Return type

[**S3Key**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3key)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## umUsersS3ssourlGet

> umUsersS3ssourlGet(userId, opts)

Retrieve S3 single sign-on URLs

Retrieve S3 Object Storage single sign-on URLs for the the specified user. The user ID is in the response body when the user is created, and in the list of the users, returned by GET.

### Examples

```javascript
const ionoscloud = require('@ionos-cloud/sdk-nodejs');
// setup authorization
const config = new ionoscloud.Configuration({
    username: 'YOUR_USERNAME',
    password: 'YOUR_PASSWORD',
    apiKey: 'YOUR_API_KEY'
});
const api_instance = new ionoscloud.UserS3KeysApi(config);
var filterMap = new Map()
filterMap.set("<property_name>", "<property_value>")
// Retrieve S3 single sign-on URLs
api_instance
  .umUsersS3ssourlGet({
    userId: userId_example,
    pretty: true,
    xContractNumber: 56, 
    orderBy: "<property_name>"
    maxResults: 2,
    filters: filterMap
    options: {}
  })
  .then((response) => console.log(response.data))
  .catch((error) => console.log(error.response.data));
```

### Parameters

| Name                | Type        | Description                                                                                                    | Notes                              |
| ------------------- | ----------- | -------------------------------------------------------------------------------------------------------------- | ---------------------------------- |
| **userId**          | **string**  | The unique ID of the user.                                                                                     | \[default to undefined]            |
| **pretty**          | **boolean** | Controls whether the response is pretty-printed (with indentations and new lines).                             | \[optional]\[default to true]      |
| **xContractNumber** | **number**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed. | \[optional]\[default to undefined] |

### Return type

[**S3ObjectStorageSSO**](https://docs.ionos.com/sections-test/nodejs-sdk/cloud-api-nodejs-sdk/models/s3objectstoragesso)

### Authorization

Basic Authentication, Token Authentication

### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json
